/*
 () 
e-mail: liloi@mail.ru
03/12/06
03/18/06

 :
l2vektor var; //  
l3vektor var; //  

:
ang_mvek(...) -   
scal_vek(...) -   
otn_x(...) -       x
otn_y(...) -       y
otn_x(...) -       z
is_veks_rav(...) -   
koor_vek(...) -  .   :

       a   b    
        l3vektor a = koor_vek(a_x, a_y, a_z, b_x, b_y, b_z);
    
    ,      ab   :
        l3vektor a = koor_vek(x,y,z);
         :
        l3vektor a;
        a.x = x;
        a.y = y;
        a.z = z;
        
abs_vektor(...) -  () 

    -   

cos_3vek_alpha(...), cos_3vek_beta(...), cos_3vek_gamma(...) -   
rot_2vek(...) -   

*/

#ifndef L_VEKTOR
#define L_VEKTOR
#include <math.h>

struct l3vektor
{
    double x;
    double y;
    double z;
};

struct l2vektor
{
    double x;
    double y;
};

double abs_vektor(l3vektor);
double abs_vektor(l2vektor);
double scal_vek(l3vektor, l3vektor);
double scal_vek(l2vektor, l2vektor);
l2vektor koor_vek(double, double);

l2vektor rot_2vek(l2vektor a, double ang)
{
    double x = a.x*cos(ang)-a.y*sin(ang);
    double y = a.y*cos(ang)+a.x*sin(ang);
    return koor_vek(x,y);
    
}

double ang_mvek(l3vektor a, l3vektor b)
{
    return acos(scal_vek(a,b)/(abs_vektor(a)*abs_vektor(b)));
}

double ang_mvek(l2vektor a, l2vektor b)
{
    return acos(scal_vek(a,b)/(abs_vektor(a)*abs_vektor(b)));
}

double scal_vek(l3vektor a, l3vektor b)
{

    return a.x*b.x + a.y*b.y + a.z*b.z;
}

double scal_vek(l2vektor a, l2vektor b)
{
    return a.x*b.x + a.y*b.y;
}

double otn_x(double x1, double x2, double otn)
{
    return (x1+otn*x2)/(1+otn);
}

double otn_y(double y1, double y2, double otn)
{
    return (y1+otn*y2)/(1+otn);
}

double otn_z(double z1, double z2, double otn)
{
    return (z1+otn*z2)/(1+otn);
}

bool is_veks_rav(l3vektor a, l3vektor b)
{
    if((a.x==b.x)&&(a.y==b.y)&&(a.z==b.z))return true; else return false;
}

bool is_veks_rav(l2vektor a, l2vektor b)
{
    if((a.x==b.x)&&(a.y==b.y))return true; else return false;
}

l3vektor koor_vek(double m_x, double m_y, double m_z, double n_x, double n_y, double n_z)
{
    l3vektor a;
    a.x = n_x - m_x;
    a.y = n_y - m_y;
    a.z = n_z - m_z;
    return a;
}

l2vektor koor_vek(double m_x, double m_y, double n_x, double n_y)
{
    l2vektor a;
    a.x = n_x - m_x;
    a.y = n_y - m_y;
    return a;
}

l3vektor koor_vek(double a_x, double a_y, double a_z)
{
    l3vektor a;
    a.x = a_x;
    a.y = a_y;
    a.z = a_z;
    return a;
}

l2vektor koor_vek(double a_x, double a_y)
{
    l2vektor a;
    a.x = a_x;
    a.y = a_y;
    return a;
}

double abs_vektor(double a_x, double a_y, double a_z)
{
    return pow((pow(a_x,2)+pow(a_y,2)+pow(a_z,2)),(0.5));
}

double abs_vektor(l3vektor a)
{
    return pow((pow(a.x,2)+pow(a.y,2)+pow(a.z,2)),(0.5));
}

double abs_vektor(double a_x, double a_y)
{
    return pow((pow(a_x,2)+pow(a_y,2)),(0.5));
}

double abs_vektor(l2vektor a)
{
    return pow((pow(a.x,2)+pow(a.y,2)),(0.5));
}

float cos_vek_alpha(double a_x, double a_y, double a_z)
{
    return a_x/(pow((pow(a_x,2)+pow(a_y,2)+pow(a_z,2)),(0.5)));
}

float cos_vek_alpha(l3vektor a)
{
    return a.x/(pow((pow(a.x,2)+pow(a.y,2)+pow(a.z,2)),(0.5)));
}

float cos_vek_beta(double a_x, double a_y, double a_z)
{
    return a_y/(pow((pow(a_x,2)+pow(a_y,2)+pow(a_z,2)),(0.5)));
}

float cos_vek_beta(l3vektor a)
{
    return a.y/(pow((pow(a.x,2)+pow(a.y,2)+pow(a.z,2)),(0.5)));
}

float cos_vek_gamma(double a_x, double a_y, double a_z)
{
    return a_z/(pow((pow(a_x,2)+pow(a_y,2)+pow(a_z,2)),(0.5)));
}

float cos_vek_gamma(l3vektor a)
{
    return a.z/(pow((pow(a.x,2)+pow(a.y,2)+pow(a.z,2)),(0.5)));
}

#endif

//


